#pragma once

#include "Const.h"
#include "OtherUnitManager.h"
#include "BuildOrderManager.h"
#include "EnemyDataManager.h"

#include "Timer.h"
#include "Debug.h"

#include <set>
#include <boost/foreach.hpp>

class CimexModule : public BWAPI::AIModule
{
private:
	Timer all_timer, exe_timer;
	double max_all,
		   max_erase,
		   max_add,
		   max_wupdate,
		   max_aupdate,
		   max_bupdate,
		   max_rupdate,
		   max_lupdate,
		   max_oupdate,
		   max_ewupdate,
		   max_eaupdate,
		   max_ebupdate,
		   max_eoupdate,
		   max_wmanage,
		   max_amanage,
		   max_omanage,
		   max_bmanage,
		   max_produce,
		   max_debug,
		   max_player,
		   max_map;

public:
	BuildOrderManager buildOrderManager;
	OtherUnitManager  otherUnitManager;
	ResourceManager   resourceManager;
	EnemyDataManager  enemyDataManager;

	CimexModule(void){
		max_all      = 0;
		max_player   = 0;
		max_map      = 0;
		max_erase    = 0;
		max_add      = 0;
		max_wupdate  = 0;
		max_aupdate  = 0;
		max_bupdate  = 0;
		max_rupdate  = 0;
		max_lupdate  = 0;
		max_oupdate  = 0;
		max_ewupdate = 0;
		max_eaupdate = 0;
		max_ebupdate = 0;
		max_eoupdate = 0;
		max_wmanage  = 0;
		max_amanage  = 0;
		max_omanage  = 0;
		max_bmanage  = 0;
		max_produce  = 0;
		max_debug    = 0;
	};
	~CimexModule(void){};

	void onStart();
	void onFrame();
	void onEnd(bool isWinner);
	void onUnitMorph(BWAPI::Unit* unit);
	void onUnitDestroy(BWAPI::Unit* unit);
	void onUnitCreate(BWAPI::Unit* unit);
	void debug();
};

