#include "Debug.h"


Debug::Debug(void)
{
}


Debug::~Debug(void)
{
}


void Debug::update(){
		//Mapɕ\
	////jbg̈ʒuɏ
	WorkerManager workerManager;
	BOOST_FOREACH(WorkerData w, workers){
		BWAPI::Broodwar->drawTextMap(w.getPosition().x(), w.getPosition().y(), w.getStateChar());
		BWAPI::Broodwar->drawTextMap(w.getPosition().x(), w.getPosition().y()+10, "HP:%d", w.getHp());
		//BWAPI::Broodwar->drawTextMap(w.getPosition().x(), w.getPosition().y()-10, w.getType().getName().c_str());
		//BWAPI::Broodwar->drawTextMap(w.getPosition().x(), w.getPosition().y()-20, w.getUnit()->getType().getName().c_str());
		if(w.getUnit()->isMorphing()) BWAPI::Broodwar->drawTextMap(w.getPosition().x(), w.getPosition().y()-10, w.getUnit()->getBuildType().c_str());
		if(w.getBuilding() != NULL) BWAPI::Broodwar->drawTextMap(w.getPosition().x(), w.getPosition().y()-20, w.getBuilding().getName().c_str());
		if(w.getBuilding() == BWAPI::UnitTypes::Zerg_Extractor) BWAPI::Broodwar->drawCircleMap(w.getPosition().x(), w.getPosition().y(), 70, BWAPI::Colors::Red);
		//BWAPI::Broodwar->drawTextMap(w.getPosition().x(), w.getPosition().y()+10, "id:%d", w.getId());
		//BWAPI::Broodwar->drawTextMap(w.getPosition().x(), w.getPosition().y()+10, "ad:%p", &w);
		//BWAPI::Broodwar->drawBoxMap(w.getPosition().x() - w.get_size()[0], w.getPosition().y() - w.get_size()[1], w.getPosition().x() + w.get_size()[2], w.getPosition().y() + w.get_size()[3], BWAPI::Colors::Green);
		if(w.getTarget() != NULL) BWAPI::Broodwar->drawLineMap(w.getPosition().x(), w.getPosition().y(), w.getTarget()->getPosition().x(), w.getTarget()->getPosition().y(), BWAPI::Colors::Yellow);
		//BWAPI::Broodwar->drawLineMap(w.getPosition().x(), w.getPosition().y(), w.getNowLocation()->getPosition().x(), w.getNowLocation()->getPosition().y(), BWAPI::Colors::Red);
		if(w.getMovetoTp() != BWAPI::TilePositions::None) BWAPI::Broodwar->drawLineMap(w.getPosition().x(), w.getPosition().y(), w.getMovetoTp().x()*32, w.getMovetoTp().y()*32, BWAPI::Colors::Yellow);
	}

	BOOST_FOREACH(AttackerData &a, attackers){
		BWAPI::Broodwar->drawTextMap(a.getPosition().x(), a.getPosition().y()-10, a.getStateChar());
		BWAPI::Broodwar->drawTextMap(a.getPosition().x(), a.getPosition().y(), "HP:%d", a.getHp());
		if(a.getType() == BWAPI::UnitTypes::Zerg_Defiler) BWAPI::Broodwar->drawCircleMap(a.getPosition().x(), a.getPosition().y(), 40, BWAPI::Colors::Blue);
		//BWAPI::Broodwar->drawTextMap(a.getPosition().x(), a.getPosition().y()+10, "%d", a.getMygroupHp());
		//BWAPI::Broodwar->drawTextMap(a.getPosition().x(), a.getPosition().y()+20, "%d", a.getEnemygroupHp());
		//if(a.getTarget() != NULL) BWAPI::Broodwar->drawLineMap(a.getPosition().x(), a.getPosition().y(), a.getTarget()->getPosition().x(), a.getTarget()->getPosition().y(), BWAPI::Colors::Yellow);
		//BWAPI::Broodwar->drawTextMap(a.getPosition().x(), a.getPosition().y()-20, a.getType().getName().c_str());
		//BWAPI::Broodwar->drawTextMap(a.getPosition().x(), a.getPosition().y()-20, a.getUnit()->getType().getName().c_str());
		if(a.getUnit()->isMorphing()) BWAPI::Broodwar->drawTextMap(a.getPosition().x(), a.getPosition().y()-20, a.getUnit()->getBuildType().c_str());
		//BWAPI::Broodwar->drawTextMap(a.getPosition().x(), a.getPosition().y()+10, "id:%d", a.getId());
		//BWAPI::Broodwar->drawTextMap(a.getPosition().x(), a.getPosition().y()+10, "ad:%p", &a);
		//BWAPI::Broodwar->drawBoxMap(a.getPosition().x() - a.get_size()[0], a.getPosition().y() - a.get_size()[1], a.getPosition().x() + a.get_size()[2], a.getPosition().y() + a.get_size()[3], BWAPI::Colors::Green);
	}


	BOOST_FOREACH(BuildingData &b, buildings){
		BWAPI::Broodwar->drawTextMap(b.getPosition().x(), b.getPosition().y(), b.getStateChar());
		BWAPI::Broodwar->drawTextMap(b.getPosition().x(), b.getPosition().y()+10, "HP:%d", b.getHp());
		//BWAPI::Broodwar->drawTextMap(b.getPosition().x(), b.getPosition().y()-10, b.getType().getName().c_str());
		//BWAPI::Broodwar->drawTextMap(b.getPosition().x(), b.getPosition().y()+10, "id:%d", b.getId());
		//BWAPI::Broodwar->drawTextMap(b.getPosition().x(), b.getPosition().y()+10, "ad:%p", &b);
		//BWAPI::Broodwar->drawBoxMap(b.getPosition().x() - b.get_size()[0], b.getPosition().y() - b.get_size()[1], b.getPosition().x() + b.get_size()[2], b.getPosition().y() + b.get_size()[3], BWAPI::Colors::Green);
	}	

	BOOST_FOREACH(ResourceData &r, resources){
		BWAPI::Broodwar->drawTextMap(r.getPosition().x(), r.getPosition().y(), "%d", r.getRemnant());
		BWAPI::Broodwar->drawTextMap(r.getPosition().x(), r.getPosition().y()-10, "%d", r.getAssignedNum());
		//BWAPI::Broodwar->drawTextMap(r.getPosition().x(), r.getPosition().y()+10, "%p", &r);
		//BWAPI::Broodwar->drawTextMap(r.getPosition().x(), r.getPosition().y()-20, r.getType().c_str());
		//BWAPI::Broodwar->drawTextMap(r.getPosition().x(), r.getPosition().y()-20, "%d", r.getPosition().getApproxDistance(BWTA::getStartLocation(BWAPI::Broodwar->self())->getPosition()));
		//BWAPI::Broodwar->drawTextMap(r.getPosition().x(), r.getPosition().y()-30, r.getUnit()->getType().c_str());
		//BWAPI::Broodwar->drawTextMap(r.getPosition().x(), r.getPosition().y()+10, "id:%d", r.getId());
		BWAPI::Broodwar->drawTextMap(r.getPosition().x(), r.getPosition().y()+10, r.getStateChar());
		//BWAPI::Broodwar->drawTextMap(r.getPosition().x(), r.getPosition().y()+10, "ad:%p", &r);
		//BWAPI::Broodwar->drawBoxMap(r.getPosition().x() - r.get_size()[0], r.getPosition().y() - r.get_size()[1], r.getPosition().x() + r.get_size()[2], r.getPosition().y() + r.get_size()[3], BWAPI::Colors::Green);
		//BWAPI::Broodwar->drawBoxMap(r.getTposition().x()*32, r.getTposition().y()*32, r.getTposition().x()*32 + 2, r.getPosition().y()*32 + 2, BWAPI::Colors::Green);
	}

	BOOST_FOREACH(LarvaData &l, larvas){
		BWAPI::Broodwar->drawTextMap(l.getPosition().x(), l.getPosition().y(), l.getBuildtype().getName().c_str());
		//BWAPI::Broodwar->drawTextMap(l.getPosition().x(), l.getPosition().y(), l.getType().getName().c_str());
		//BWAPI::Broodwar->drawTextMap(l.getPosition().x(), l.getPosition().y()-10, l.getUnit()->getType().getName().c_str());
		//BWAPI::Broodwar->drawTextMap(l.getPosition().x(), l.getPosition().y()+10, "id:%d", l.getId());
		//BWAPI::Broodwar->drawTextMap(l.getPosition().x(), l.getPosition().y()+10, "ad:%p", &l);
		//if(l.getUnit()->isMorphing()) BWAPI::Broodwar->drawTextMap(l.getPosition().x(), l.getPosition().y(), l.getUnit()->getBuildType().c_str());
		//BWAPI::Broodwar->drawBoxMap(l.getPosition().x() - l.get_size()[0], l.getPosition().y() - l.get_size()[1], l.getPosition().x() + l.get_size()[2], l.getPosition().y() + l.get_size()[3], BWAPI::Colors::Green);
	}

	BOOST_FOREACH(OtherUnitData &o, others){
		BWAPI::Broodwar->drawTextMap(o.getPosition().x(), o.getPosition().y(), o.getStateChar());
		BWAPI::Broodwar->drawTextMap(o.getPosition().x(), o.getPosition().y()+10, "HP:%d", o.getHp());
		//BWAPI::Broodwar->drawTextMap(o.getPosition().x(), o.getPosition().y()-10, o.getType().getName().c_str());
		//BWAPI::Broodwar->drawTextMap(o.getPosition().x(), o.getPosition().y()-20, o.getUnit()->getType().getName().c_str());
		if(o.getUnit()->isMorphing()) BWAPI::Broodwar->drawTextMap(o.getPosition().x(), o.getPosition().y()-10, o.getUnit()->getBuildType().c_str());
		//BWAPI::Broodwar->drawTextMap(o.getPosition().x(), o.getPosition().y()+10, "id:%d", o.getId());
		//BWAPI::Broodwar->drawTextMap(o.getPosition().x(), o.getPosition().y()+10, "ad:%p", &o);
		//BWAPI::Broodwar->drawBoxMap(o.getPosition().x() - o.get_size()[0], o.getPosition().y() - o.get_size()[1], o.getPosition().x() + o.get_size()[2], o.getPosition().y() + o.get_size()[3], BWAPI::Colors::Green);
	}

	////EnemyUnit
	BOOST_FOREACH(WorkerData &w, eworkers){
		BWAPI::Broodwar->drawTextMap(w.getPosition().x(), w.getPosition().y(), "Worker");
		BWAPI::Broodwar->drawTextMap(w.getPosition().x(), w.getPosition().y()+10, "HP:%d", w.getHp());
		//BWAPI::Broodwar->drawTextMap(w.getPosition().x(), w.getPosition().y()-10, w.getType().getName().c_str());
		//BWAPI::Broodwar->drawTextMap(w.getPosition().x(), w.getPosition().y()+10, "id:%d", w.getId());
		//BWAPI::Broodwar->drawTextMap(w.getPosition().x(), w.getPosition().y()+10, "ad:%p", &w);
		//BWAPI::Broodwar->drawBoxMap(w.getPosition().x() - w.get_size()[0], w.getPosition().y() - w.get_size()[1], w.getPosition().x() + w.get_size()[2], w.getPosition().y() + w.get_size()[3], BWAPI::Colors::Green);
	}

	BOOST_FOREACH(AttackerData &a, eattackers){
		BWAPI::Broodwar->drawTextMap(a.getPosition().x(), a.getPosition().y(), "Attacker");
		BWAPI::Broodwar->drawTextMap(a.getPosition().x(), a.getPosition().y()+10, "HP:%d", a.getHp());
		//BWAPI::Broodwar->drawTextMap(a.getPosition().x(), a.getPosition().y()-10, a.getType().getName().c_str());
		//BWAPI::Broodwar->drawTextMap(a.getPosition().x(), a.getPosition().y()+10, "id:%d", a.getId());
		//BWAPI::Broodwar->drawTextMap(a.getPosition().x(), a.getPosition().y()+10, "ad:%p", &a);
		//BWAPI::Broodwar->drawBoxMap(a.getPosition().x() - a.get_size()[0], a.getPosition().y() - a.get_size()[1], a.getPosition().x() + a.get_size()[2], a.getPosition().y() + a.get_size()[3], BWAPI::Colors::Green);
	}


	BOOST_FOREACH(BuildingData &b, ebuildings){
		BWAPI::Broodwar->drawTextMap(b.getPosition().x(), b.getPosition().y(), "Building");
		BWAPI::Broodwar->drawTextMap(b.getPosition().x(), b.getPosition().y()+10, "HP:%d", b.getHp());
		//BWAPI::Broodwar->drawTextMap(b.getPosition().x(), b.getPosition().y()-10, b.getType().getName().c_str());
		//BWAPI::Broodwar->drawTextMap(b.getPosition().x(), b.getPosition().y()+10, "id:%d", b.getId());
		//BWAPI::Broodwar->drawTextMap(b.getPosition().x(), b.getPosition().y()+10, "ad:%p", &b);
		//BWAPI::Broodwar->drawBoxMap(b.getPosition().x() - b.get_size()[0], b.getPosition().y() - b.get_size()[1], b.getPosition().x() + b.get_size()[2], b.getPosition().y() + b.get_size()[3], BWAPI::Colors::Green);
	}


	BOOST_FOREACH(OtherUnitData &o, eothers){
		BWAPI::Broodwar->drawTextMap(o.getPosition().x(), o.getPosition().y(), "Other");
		BWAPI::Broodwar->drawTextMap(o.getPosition().x(), o.getPosition().y()+10, "HP:%d", o.getHp());
		//BWAPI::Broodwar->drawTextMap(o.getPosition().x(), o.getPosition().y()-10, o.getType().getName().c_str());
		//BWAPI::Broodwar->drawTextMap(o.getPosition().x(), o.getPosition().y()+10, "id:%d", o.getId());
		//BWAPI::Broodwar->drawTextMap(o.getPosition().x(), o.getPosition().y()+10, "ad:%p", &o);
		//BWAPI::Broodwar->drawBoxMap(o.getPosition().x() - o.get_size()[0], o.getPosition().y() - o.get_size()[1], o.getPosition().x() + o.get_size()[2], o.getPosition().y() + o.get_size()[3], BWAPI::Colors::Green);
	}


	////BaseLocation̈ʒuɏ
	
	{
		std::pair<BWTA::BaseLocation*, int> mb;
		BOOST_FOREACH(mb, mapdata.getMybases()){
			BWAPI::Broodwar->drawBoxMap(mb.first->getPosition().x(), mb.first->getPosition().y(), mb.first->getPosition().x() + TILE_SIZE, mb.first->getPosition().y() + TILE_SIZE, BWAPI::Colors::Blue);
			BWAPI::Broodwar->drawTextMap(mb.first->getPosition().x() + TILE_SIZE*2 -10, mb.first->getPosition().y() - TILE_SIZE*2, "%d", mb.second);
		}

		std::pair<BWTA::BaseLocation*, bool> eb;
		BOOST_FOREACH(eb, mapdata.getEnemybases()){
			BWAPI::Broodwar->drawBoxMap(eb.first->getPosition().x(), eb.first->getPosition().y(), eb.first->getPosition().x() + TILE_SIZE, eb.first->getPosition().y() + TILE_SIZE, BWAPI::Colors::Red);
			BWAPI::Broodwar->drawTextMap(eb.first->getPosition().x() + TILE_SIZE*2 -10, eb.first->getPosition().y() - TILE_SIZE*2, "%d", eb.second);
		}
	}

	//BWAPI::Broodwar->drawCircleMap(ppp.x(), ppp.y(), 100, BWAPI::Colors::Cyan);

	
	//Screenɏ
	BWAPI::Broodwar->drawTextScreen(10, 0, "Strategy : %d   WinningStreak : %d", strategy_num, winning_streak);

	BWAPI::Broodwar->drawTextScreen(70, 40, "Self");                 BWAPI::Broodwar->drawTextScreen(100, 40, "Enemy");
	BWAPI::Broodwar->drawTextScreen(10, 50, "Workers");   BWAPI::Broodwar->drawTextScreen(77, 50, "%d", workers.size());             BWAPI::Broodwar->drawTextScreen(110, 50, "%d", eworkers.size());
	BWAPI::Broodwar->drawTextScreen(10, 60, "Attackers"); BWAPI::Broodwar->drawTextScreen(77, 60, "%d", attackers.size());           BWAPI::Broodwar->drawTextScreen(110, 60, "%d", eattackers.size());
	BWAPI::Broodwar->drawTextScreen(10, 70, "Buildings"); BWAPI::Broodwar->drawTextScreen(77, 70, "%d", buildings.size());           BWAPI::Broodwar->drawTextScreen(110, 70, "%d", ebuildings.size());
	BWAPI::Broodwar->drawTextScreen(10, 80, "Resources"); BWAPI::Broodwar->drawTextScreen(77, 80, "%d", resources.size());
	BWAPI::Broodwar->drawTextScreen(10, 90, "Larvas");    BWAPI::Broodwar->drawTextScreen(77, 90, "%d", larvas.size());
	BWAPI::Broodwar->drawTextScreen(10, 100, "Others");   BWAPI::Broodwar->drawTextScreen(77, 100, "%d", others.size());             BWAPI::Broodwar->drawTextScreen(110, 100, "%d", eothers.size());

	//Ŏ擾Ă鎑\
	BWAPI::Broodwar->drawTextScreen(452, 20, "%d", playerdata.get_mineral());
	BWAPI::Broodwar->drawTextScreen(520, 20, "%d", playerdata.get_gas());
	BWAPI::Broodwar->drawTextScreen(584, 20, "%d/%d", playerdata.get_supplyused(), playerdata.get_supplytotal());

	//MapŎ擾Ă{\
	BWAPI::Broodwar->drawTextScreen(10, 10, "MapSize  : %d * %d", mapdata.getMapwidth(), mapdata.getMapheight());
	BWAPI::Broodwar->drawTextScreen(150, 10, "CurrentFrame  : %d", BWAPI::Broodwar->getFrameCount());

	//mapdata
	BWAPI::Broodwar->drawTextScreen(10, 150, "next_mybase : %d", CimexFlag::next_mybase_flag);
	BWAPI::Broodwar->drawTextScreen(10, 160, "mybase_num : %d", mapdata.getMybaseNum());
	BWAPI::Broodwar->drawTextScreen(10, 170, "mybase size : %d", mapdata.getMybases().size());
	BWAPI::Broodwar->drawTextScreen(10, 180, "enemybase size : %d", mapdata.getEnemybases().size());
	BWAPI::Broodwar->drawTextScreen(10, 190, "no_resource_flag : %d", CimexFlag::no_resource_flag);

	////BuildOrder
	//BWAPI::Broodwar->drawTextScreen(10,200, "reserve_zerg_spawning_pool : %d", CimexFlag::reserve_zerg_spawning_pool);
	BWAPI::Broodwar->drawTextScreen(200,40, "drone");		BWAPI::Broodwar->drawTextScreen(327, 40, "%d", BuildOrderData::drone_num);       BWAPI::Broodwar->drawTextScreen(360, /*21*/40, "%d", BuildOrderData::build_order_index);
	BWAPI::Broodwar->drawTextScreen(200,50, "base");	    BWAPI::Broodwar->drawTextScreen(327, 50, "%d", BuildOrderData::hold_num[BuildOrderType::Base]);        BWAPI::Broodwar->drawTextScreen(360, 50, "%d", build_order[BuildOrderData::build_order_index][BuildOrderType::Base] - BuildOrderData::hold_num[BuildOrderType::Base]);
	BuildOrderManager buildOrderManager;
	{
		int y = 60;
		for(int i=0; i<BuildOrderType::Base; i++){
			if(build_order[BuildOrderData::build_order_index][i] == 0) continue;
			if(i >= BuildOrderType::Brooding && i <= BuildOrderType::UltraliskCavern) BWAPI::Broodwar->drawTextScreen(200,y, "%s", buildOrderManager.getUnitType(i).c_str());	BWAPI::Broodwar->drawTextScreen(327, y, "%d", BuildOrderData::hold_num[i]);    BWAPI::Broodwar->drawTextScreen(360, y, "%d", build_order[BuildOrderData::build_order_index][i] - BuildOrderData::hold_num[i]);
			if(i >= BuildOrderType::Carapace && i <= BuildOrderType::GameteMeiosis) BWAPI::Broodwar->drawTextScreen(200,y, "%s", buildOrderManager.getUpgradeType(i).c_str());	BWAPI::Broodwar->drawTextScreen(327, y, "%d", BuildOrderData::hold_num[i]);    BWAPI::Broodwar->drawTextScreen(360, y, "%d", build_order[BuildOrderData::build_order_index][i] - BuildOrderData::hold_num[i]);
			if(i >= BuildOrderType::Burrowing && i <= BuildOrderType::Parasite) BWAPI::Broodwar->drawTextScreen(200,y, "%s", buildOrderManager.getTechType(i).c_str());	BWAPI::Broodwar->drawTextScreen(327, y, "%d", BuildOrderData::hold_num[i]);    BWAPI::Broodwar->drawTextScreen(360, y, "%d", build_order[BuildOrderData::build_order_index][i] - BuildOrderData::hold_num[i]);
			y += 10;
		}
	}
	//BWAPI::Broodwar->drawTextScreen(10,230, "hatchery");	BWAPI::Broodwar->drawTextScreen(77, 230, "%d", BuildOrderData::hold_num[BuildOrderType::Hatchery]);    BWAPI::Broodwar->drawTextScreen(110, 230, "%d", build_order[BuildOrderData::build_order_index][BuildOrderType::Hatchery] - BuildOrderData::hold_num[BuildOrderType::Hatchery]);
	//BWAPI::Broodwar->drawTextScreen(10,240, "overload");	BWAPI::Broodwar->drawTextScreen(77, 240, "%d", BuildOrderData::hold_num[BuildOrderType::Overload]);    BWAPI::Broodwar->drawTextScreen(110, 240, "%d", build_order[BuildOrderData::build_order_index][BuildOrderType::Overload] - BuildOrderData::hold_num[BuildOrderType::Overload]);
	//BWAPI::Broodwar->drawTextScreen(10,250, "pool");	    BWAPI::Broodwar->drawTextScreen(77, 250, "%d", BuildOrderData::hold_num[BuildOrderType::SpawningPool]);        BWAPI::Broodwar->drawTextScreen(110, 250, "%d", build_order[BuildOrderData::build_order_index][BuildOrderType::SpawningPool] - BuildOrderData::hold_num[BuildOrderType::SpawningPool]);
	//BWAPI::Broodwar->drawTextScreen(10,260, "zergling");	BWAPI::Broodwar->drawTextScreen(77, 260, "%d", BuildOrderData::hold_num[BuildOrderType::Zergling]);    BWAPI::Broodwar->drawTextScreen(110, 260, "%d", build_order[BuildOrderData::build_order_index][BuildOrderType::Zergling] - BuildOrderData::hold_num[BuildOrderType::Zergling]);
	//BWAPI::Broodwar->drawTextScreen(10,270, "extractor");	BWAPI::Broodwar->drawTextScreen(77, 270, "%d", BuildOrderData::hold_num[BuildOrderType::Extractor]);    BWAPI::Broodwar->drawTextScreen(110, 270, "%d", build_order[BuildOrderData::build_order_index][BuildOrderType::Extractor] - BuildOrderData::hold_num[BuildOrderType::Extractor]);
	BWAPI::Broodwar->drawTextScreen(10,280, "orderDrone : %d", playerdata.orderDrone());
	//BWAPI::Broodwar->drawTextScreen(10,290, "overloadCM : %d", playerdata.canMake(BWAPI::UnitTypes::Zerg_Overlord));

	//BWAPI::Broodwar->drawTextScreen(10,210, "zerg_spawning_pool : %d", CimexFlag::zerg_spawning_pool);
	//BWAPI::Broodwar->drawTextScreen(10,220, "reserve_zerg_hatchery : %d", CimexFlag::reserve_zerg_hatchery);
	//BWAPI::Broodwar->drawTextScreen(10,230, "overload_flag : %d", CimexFlag::init_overload);
	//BWAPI::Broodwar->drawTextScreen(10,240, "next_mybase_flag : %d", CimexFlag::next_mybase_flag);
	//BWAPI::Broodwar->drawTextScreen(10,250, "scout_flag : %d", CimexFlag::scout_flag);
	//BWAPI::Broodwar->drawTextScreen(10,220, "zerg_lair : %d", CimexFlag::zerg_lair);
	//BWAPI::Broodwar->drawTextScreen(10,230, "zerg hive : %d", CimexFlag::zerg_hive);
	//BWAPI::Broodwar->drawTextScreen(10,240, "reserve_zerg_queens_nest : %d", CimexFlag::reserve_zerg_queens_nest);
	//BWAPI::Broodwar->drawTextScreen(10,250, "zerg_queens_nest : %d", CimexFlag::zerg_queens_nest);
	//BWAPI::Broodwar->drawTextScreen(10,260, "complete_zerg_lair : %d", CimexFlag::complete_zerg_lair);

	//BWAPI::Broodwar->drawTextScreen(50, 130, "reserved building : %d", reservebuildings.get_rwmap().size());
	//BWAPI::Broodwar->drawTextScreen(50, 160, "BaseLocation size : %d", BWTA::getBaseLocations().size());

	/*
	for(int i=0; i<mapdata.get_mapwidth(); i++){
	for(int j=0; j<mapdata.get_mapheight(); j++){
	if(mapdata.get_buildable_map()[i][j])
	BWAPI::Broodwar->drawDotMap(i*32, j*32, BWAPI::Colors::Blue);
	else
	BWAPI::Broodwar->drawDotMap(i*32, j*32, BWAPI::Colors::Red);
	}
	}*/

	/*
	int j=0;
	BOOST_FOREACH(int id, pre_id){
	BWAPI::Broodwar->drawTextScreen(10 + j * 20, 10, "%d", id);
	j++;
	}
	*/

}

