#pragma once
#include "UnitData.h"
#include "Const.h"
class AttackerData : public UnitData
{
private:
	int state;
	int hp;
	BWAPI::Unit* target;
	BWTA::BaseLocation* now_location;
	
public:

	AttackerData(BWAPI::Unit * u);

	AttackerData();

	~AttackerData(void);

	void update();

	void eupdate();

	char * getStateChar() const;

	int getState() const;

	int getHp() const;

	BWAPI::Unit * getTarget();


	BWTA::BaseLocation* getNowLocation() const;

	void setNowLocation(BWTA::BaseLocation* b);

	void setTarget(BWAPI::Unit* u);

	void setState(const int &i);


};

