#include "BuildOrderManager.h"

BuildOrderManager::BuildOrderManager(void)
{
}


BuildOrderManager::~BuildOrderManager(void)
{
}

void BuildOrderManager::init(){
	generateBuildOrder.init();
}


void BuildOrderManager::update(){
	for(int i=0; i<BuildOrderType::Max; i++) BuildOrderData::hold_num[i] = 0;
	out << "20-1" << std::endl;
	//unit̐𐔂
	countHoldNum();

	out << "20-2" << std::endl;
	for(int i = 1; i < 100; i++){
		if(checkComplete(BuildOrderData::drone_num - i)){
				BuildOrderData::build_order_index = BuildOrderData::drone_num - i + 1;
				break;
		}
	}

	if(BuildOrderData::build_order_index < 0)   BuildOrderData::build_order_index = 0;
	if(BuildOrderData::build_order_index > 100) BuildOrderData::build_order_index = 100;

	out << "20-3" << std::endl;
	//BWAPI::Broodwar->drawTextScreen(10,270, "pmake : %d", playerdata.canMake(BWAPI::UnitTypes::Zerg_Drone));
	//BWAPI::Broodwar->drawTextScreen(10,260, "bmake : %d", BWAPI::Broodwar->canMake(NULL, BWAPI::UnitTypes::Zerg_Drone));
	//BWAPI::Broodwar->drawTextScreen(10,250, "100 : %d", BuildOrderData::drone_num < 100);
	while(1){
		//out2 << "1" << std::endl;
		if(checkComplete(BuildOrderData::build_order_index) && !playerdata.orderDrone() && BuildOrderData::build_order_index < 100)
			BuildOrderData::build_order_index++;

		//out2 << "2" << std::endl;
		bool flag = searchBuildOrder();
		//BWAPI::Broodwar->drawTextScreen(10, 140, "Buildorder : %d", flag);
		if(!flag){
			//out2 << "2-1" << std::endl;
			if(build_order[BuildOrderData::build_order_index][BuildOrderType::Overload] - BuildOrderData::hold_num[BuildOrderType::Overload] <= 0 && BWAPI::Broodwar->self()->supplyTotal() - BWAPI::Broodwar->self()->supplyUsed() <= 0)
				productionManager.morphLarva(getUnitType(BuildOrderType::Overload)); //kɑĂȂjbg邪Overload͑Ă̂supplyȂ󋵂
			else break;
		}
		if(playerdata.canMake(BWAPI::UnitTypes::Zerg_Drone) && playerdata.orderDrone() && BWAPI::Broodwar->canMake(NULL, BWAPI::UnitTypes::Zerg_Drone) && BuildOrderData::drone_num < 100){
			//out2 << "2-2" << std::endl;
			flag = productionManager.morphLarva(BWAPI::UnitTypes::Zerg_Drone);
			if(!flag) break;
			playerdata.reserv(BWAPI::UnitTypes::Zerg_Drone);
		}else break;
		//out2 << "3" << std::endl;
		if(logging_flag2) out2 << ",";
		//canMakełȂlarvaworkerȂȂbreak
	}
	//out2 << std::endl;
	//out << "20-4" << std::endl;
	productionManager.updateMorphNum(build_order[BuildOrderData::build_order_index + 5][BuildOrderType::Lurker] - BuildOrderData::hold_num[BuildOrderType::Lurker],
		(build_order[BuildOrderData::build_order_index + 5][BuildOrderType::Devourer]  - BuildOrderData::hold_num[BuildOrderType::Devourer]) + (build_order[BuildOrderData::build_order_index + 5][BuildOrderType::Guardian]  - BuildOrderData::hold_num[BuildOrderType::Guardian]));

}

//肽̂̂ɍȂƂfalse, 肽͍̂AŌ܂łȂ߂true
bool BuildOrderManager::searchBuildOrder(){
	bool return_flag = true; 
	for(int i=0; i<BuildOrderType::Max; i++){
		if(build_order[BuildOrderData::build_order_index][i] - BuildOrderData::hold_num[i] <= 0) continue;
		out2 << i << std::endl;
		bool flag = false;
		if(i >= BuildOrderType::Brooding && i <= BuildOrderType::Scourge){//Unit
			BWAPI::UnitType type = getUnitType(i);
			if(i == BuildOrderType::Brooding){//Queen

			}else if(i ==  BuildOrderType::Lurker || i ==  BuildOrderType::Devourer || i ==  BuildOrderType::Guardian){//Unit->morph
				if(playerdata.canMake(type) && BWAPI::Broodwar->canMake(NULL, type)){
					flag = productionManager.morphAttacker(type);
					if(!flag){
						return_flag = false;
						continue;
					}
					playerdata.reserv(type);
					BuildOrderData::hold_num[i]++;
				}else return_flag = false;

			}else{//Larva->morph
				if(playerdata.canMake(type) && BWAPI::Broodwar->canMake(NULL, type)){
					flag = productionManager.morphLarva(type);
					if(!flag){
						return_flag = false;
						continue;
					}
					playerdata.reserv(type);
					BuildOrderData::hold_num[i]++;
				}else return_flag = false;
			}


		}else if(i >= BuildOrderType::CreepColony && i <= BuildOrderType::UltraliskCavern || i == BuildOrderType::Base){//Building
			BWAPI::UnitType type = getUnitType(i);
			if(i == BuildOrderType::Lair || i == BuildOrderType::Hive || i == BuildOrderType::SunkenColony || i == BuildOrderType::SporeColony || i == BuildOrderType::GreaterSpire){//Building->morph
				if(playerdata.canMake(type)){
					flag = constructionManager.buildBuilding(type);
					if(!flag){
						return_flag = false;
						continue;
					}
					playerdata.reserv(type);
					BuildOrderData::hold_num[i]++;
				}else return_flag = false;

			}else if(i == BuildOrderType::Base){
				if(playerdata.canMake(type)){
					flag = constructionManager.buildWorker(type);
					if(!flag){
						return_flag = false;
						continue;
					}
					playerdata.add_build_reserv(type);
					BuildOrderData::hold_num[i]++;
				}else return_flag = false;
			}else{//Drone->morph
				if(playerdata.canMake(type)){
					flag = constructionManager.buildWorker(type);
					if(!flag){
						return_flag = false;
						continue;
					}
					playerdata.add_build_reserv(type);
					BuildOrderData::hold_num[i]++;
				}else return_flag = false;
			}


		}else if(i >= BuildOrderType::Carapace && i <= BuildOrderType::GameteMeiosis){//Upgrade
			BWAPI::UpgradeType type = getUpgradeType(i);
			if(playerdata.canUpgrade(type)){
				flag = constructionManager.upgradeBuilding(type);
				if(!flag){
					return_flag = false;
					continue;
				}
				playerdata.reserv(type);
				BuildOrderData::hold_num[i]++;
			}else return_flag = false;


		}else if(i >= BuildOrderType::Burrowing && i <= BuildOrderType::Parasite){//tech
			BWAPI::TechType type = getTechType(i);
			if(playerdata.canResearch(type)){
				flag = constructionManager.researchBuilding(type);
				if(!flag){
					return_flag = false;
					continue;
				}
				playerdata.reserv(type);
				BuildOrderData::hold_num[i]++;
			}else return_flag = false;
		}
	}
	return return_flag;
}


bool BuildOrderManager::checkComplete(int index){
	for(int i=0; i<BuildOrderType::Max; i++){
		if(build_order[index][i] - BuildOrderData::hold_num[i] > 0) return false;
	}
	return true;
}

BWAPI::UnitType BuildOrderManager::getUnitType(int type){
	if((type >= BuildOrderType::Carapace || type < 0) && type != BuildOrderType::Base)  return BWAPI::UnitTypes::None;
	else if(type == BuildOrderType::Brooding)         return BWAPI::UnitTypes::Zerg_Broodling;
	else if(type == BuildOrderType::Defiler)          return BWAPI::UnitTypes::Zerg_Defiler;
	else if(type == BuildOrderType::Hydralisk)        return BWAPI::UnitTypes::Zerg_Hydralisk;
	else if(type == BuildOrderType::Lurker)           return BWAPI::UnitTypes::Zerg_Lurker;
	else if(type == BuildOrderType::Ultralisk)        return BWAPI::UnitTypes::Zerg_Ultralisk;
	else if(type == BuildOrderType::Zergling)         return BWAPI::UnitTypes::Zerg_Zergling;
	else if(type == BuildOrderType::Devourer)         return BWAPI::UnitTypes::Zerg_Devourer;
	else if(type == BuildOrderType::Guardian)         return BWAPI::UnitTypes::Zerg_Guardian;
	else if(type == BuildOrderType::Mutalisk)         return BWAPI::UnitTypes::Zerg_Mutalisk;
	else if(type == BuildOrderType::Overload)         return BWAPI::UnitTypes::Zerg_Overlord;
	else if(type == BuildOrderType::Queen)            return BWAPI::UnitTypes::Zerg_Queen;
	else if(type == BuildOrderType::Scourge)          return BWAPI::UnitTypes::Zerg_Scourge;
	else if(type == BuildOrderType::CreepColony)      return BWAPI::UnitTypes::Zerg_Creep_Colony;
	else if(type == BuildOrderType::DefilerMound)     return BWAPI::UnitTypes::Zerg_Defiler_Mound;
	else if(type == BuildOrderType::EvolutionChamber) return BWAPI::UnitTypes::Zerg_Evolution_Chamber;
	else if(type == BuildOrderType::Extractor)        return BWAPI::UnitTypes::Zerg_Extractor;
	else if(type == BuildOrderType::GreaterSpire)     return BWAPI::UnitTypes::Zerg_Greater_Spire;
	else if(type == BuildOrderType::Hatchery)         return BWAPI::UnitTypes::Zerg_Hatchery;
	else if(type == BuildOrderType::Hive)             return BWAPI::UnitTypes::Zerg_Hive;
	else if(type == BuildOrderType::HydraliskDen)     return BWAPI::UnitTypes::Zerg_Hydralisk_Den;
	else if(type == BuildOrderType::Lair)             return BWAPI::UnitTypes::Zerg_Lair;
	else if(type == BuildOrderType::NydusCanel)       return BWAPI::UnitTypes::Zerg_Nydus_Canal;
	else if(type == BuildOrderType::QueensNest)       return BWAPI::UnitTypes::Zerg_Queens_Nest;
	else if(type == BuildOrderType::SpawningPool)     return BWAPI::UnitTypes::Zerg_Spawning_Pool;
	else if(type == BuildOrderType::Spire)            return BWAPI::UnitTypes::Zerg_Spire;
	else if(type == BuildOrderType::SporeColony)      return BWAPI::UnitTypes::Zerg_Spore_Colony;
	else if(type == BuildOrderType::SunkenColony)     return BWAPI::UnitTypes::Zerg_Sunken_Colony;
	else if(type == BuildOrderType::UltraliskCavern)  return BWAPI::UnitTypes::Zerg_Ultralisk_Cavern;
	else if(type == BuildOrderType::Base)             return BWAPI::UnitTypes::Zerg_Hatchery;
	return BWAPI::UnitTypes::None;
}

BWAPI::UpgradeType BuildOrderManager::getUpgradeType(int type){
	if(type >= BuildOrderType::Burrowing || type < BuildOrderType::Carapace) return BWAPI::UpgradeTypes::None;
	else if(type == BuildOrderType::Carapace)                                return BWAPI::UpgradeTypes::Zerg_Carapace;
	else if(type == BuildOrderType::MeleeAtack)                              return BWAPI::UpgradeTypes::Zerg_Melee_Attacks;
	else if(type == BuildOrderType::MetasynapticNode)                        return BWAPI::UpgradeTypes::Metasynaptic_Node;
	else if(type == BuildOrderType::MissileAttacks)                          return BWAPI::UpgradeTypes::Zerg_Missile_Attacks;
	else if(type == BuildOrderType::MuscularAugment)                         return BWAPI::UpgradeTypes::Muscular_Augments;
	else if(type == BuildOrderType::GroovedSpines)                           return BWAPI::UpgradeTypes::Grooved_Spines;
	else if(type == BuildOrderType::ChitinousPlating)                        return BWAPI::UpgradeTypes::Chitinous_Plating;
	else if(type == BuildOrderType::AnabolicSynthesis)                       return BWAPI::UpgradeTypes::Anabolic_Synthesis;
	else if(type == BuildOrderType::MetabolicBoost)                          return BWAPI::UpgradeTypes::Metabolic_Boost;
	else if(type == BuildOrderType::AdrenalGlands)                           return BWAPI::UpgradeTypes::Adrenal_Glands;
	else if(type == BuildOrderType::FlyerCarapace)                           return BWAPI::UpgradeTypes::Zerg_Flyer_Carapace;
	else if(type == BuildOrderType::FlyerAttacks)                            return BWAPI::UpgradeTypes::Zerg_Flyer_Attacks;
	else if(type == BuildOrderType::VentralSacs)                             return BWAPI::UpgradeTypes::Ventral_Sacs;
	else if(type == BuildOrderType::Antennae)                                return BWAPI::UpgradeTypes::Antennae;
	else if(type == BuildOrderType::PneumatizedCarapace)                     return BWAPI::UpgradeTypes::Pneumatized_Carapace;
	else if(type == BuildOrderType::GameteMeiosis)                           return BWAPI::UpgradeTypes::Gamete_Meiosis;
	return BWAPI::UpgradeTypes::None;
}

BWAPI::TechType BuildOrderManager::getTechType(int type){
	if(type >= BuildOrderType::Base || type < BuildOrderType::Burrowing) return BWAPI::TechTypes::None;
	else if(type == BuildOrderType::Burrowing)                           return BWAPI::TechTypes::Burrowing;
	else if(type == BuildOrderType::DarkSwarm)                           return BWAPI::TechTypes::Dark_Swarm;
	else if(type == BuildOrderType::Plague)                              return BWAPI::TechTypes::Plague;
	else if(type == BuildOrderType::Consume)                             return BWAPI::TechTypes::Consume;
	else if(type == BuildOrderType::LurkerAspect)                        return BWAPI::TechTypes::Lurker_Aspect;
	else if(type == BuildOrderType::Infestation)                         return BWAPI::TechTypes::Infestation;
	else if(type == BuildOrderType::SpawnBroodings)                      return BWAPI::TechTypes::Spawn_Broodlings;
	else if(type == BuildOrderType::Ensnare)                             return BWAPI::TechTypes::Ensnare;
	else if(type == BuildOrderType::Parasite)                            return BWAPI::TechTypes::Parasite;
	return BWAPI::TechTypes::None;
}

void BuildOrderManager::countHoldNum(){
	BuildOrderData::drone_num = workers.size();
	BuildOrderData::hold_num[BuildOrderType::Overload] = others.size();
	BuildOrderData::hold_num[BuildOrderType::Base] = mapdata.getMybaseNum();

	////attacker̐
	BOOST_FOREACH(AttackerData &a, attackers){
		if(a.getType() == BWAPI::UnitTypes::Zerg_Egg && a.getUnit()->getBuildType() == BWAPI::UnitTypes::Zerg_Zergling) BuildOrderData::hold_num[BuildOrderType::Zergling] += 2;
		else if(a.getType() == BWAPI::UnitTypes::Zerg_Lurker_Egg || a.getType() == BWAPI::UnitTypes::Zerg_Lurker){BuildOrderData::hold_num[BuildOrderType::Lurker]++; BuildOrderData::hold_num[BuildOrderType::Hydralisk]++;}
		else{
			for(int i=0; i<=BuildOrderType::Scourge; i++){
				if(a.getType() == getUnitType(i)){
					BuildOrderData::hold_num[i]++;
					break;
				}else if(a.getType() == BWAPI::UnitTypes::Zerg_Egg){
					if(a.getUnit()->getBuildType() == getUnitType(i)){
						BuildOrderData::hold_num[i]++;
						break;
					}
				}
			}
		}
	}

	////ωwߒunit̐
	BOOST_FOREACH(LarvaData &l, larvas){
		if(l.getBuildtype() == BWAPI::UnitTypes::Zerg_Drone) BuildOrderData::drone_num++;
		else if(l.getBuildtype() == BWAPI::UnitTypes::Zerg_Zergling) BuildOrderData::hold_num[BuildOrderType::Zergling] += 2;
		else{
			for(int i=0; i<=BuildOrderType::Scourge; i++){
				if(l.getBuildtype() == getUnitType(i)){
					BuildOrderData::hold_num[i]++;
					break;
				}
			}
		}
	}


	////building̐
	BOOST_FOREACH(BuildingData &b, buildings){
		if(b.getType() == BWAPI::UnitTypes::Zerg_Sunken_Colony){ BuildOrderData::hold_num[BuildOrderType::SunkenColony]++; BuildOrderData::hold_num[BuildOrderType::CreepColony]++;}
		else if(b.getType() == BWAPI::UnitTypes::Zerg_Spore_Colony){ BuildOrderData::hold_num[BuildOrderType::SporeColony]++; BuildOrderData::hold_num[BuildOrderType::CreepColony]++;}
		else if(b.getType() == BWAPI::UnitTypes::Zerg_Greater_Spire){ BuildOrderData::hold_num[BuildOrderType::GreaterSpire]++; BuildOrderData::hold_num[BuildOrderType::Spire]++;}
		else if(b.getType() == BWAPI::UnitTypes::Zerg_Lair){ BuildOrderData::hold_num[BuildOrderType::Lair]++; BuildOrderData::hold_num[BuildOrderType::Hatchery]++;}
		else if(b.getType() == BWAPI::UnitTypes::Zerg_Hive){ BuildOrderData::hold_num[BuildOrderType::Hive]++; BuildOrderData::hold_num[BuildOrderType::Lair]++; BuildOrderData::hold_num[BuildOrderType::Hatchery]++;}
		else{
			for(int i=BuildOrderType::CreepColony; i<=BuildOrderType::UltraliskCavern; i++){
				if(b.getType() == getUnitType(i)){
					BuildOrderData::hold_num[i]++;
					break;
				}
			}
		}
	}


	BOOST_FOREACH(ResourceData &r, resources){
		if(r.getType().isRefinery() && r.getState() == ResourceState::Mine) BuildOrderData::hold_num[BuildOrderType::Extractor]++;
	}

	////workerwߒbuilding̐
	BOOST_FOREACH(WorkerData w, workers){
		if(w.getState() != WorkerState::Build) continue;

		if(w.getBuilding() == BWAPI::UnitTypes::Zerg_Sunken_Colony){ BuildOrderData::hold_num[BuildOrderType::SunkenColony]++; BuildOrderData::hold_num[BuildOrderType::CreepColony]++;}
		else if(w.getBuilding() == BWAPI::UnitTypes::Zerg_Spore_Colony){ BuildOrderData::hold_num[BuildOrderType::SporeColony]++; BuildOrderData::hold_num[BuildOrderType::CreepColony]++;}
		else if(w.getBuilding() == BWAPI::UnitTypes::Zerg_Greater_Spire){ BuildOrderData::hold_num[BuildOrderType::GreaterSpire]++; BuildOrderData::hold_num[BuildOrderType::Spire]++;}
		else if(w.getBuilding() == BWAPI::UnitTypes::Zerg_Lair){ BuildOrderData::hold_num[BuildOrderType::Lair]++; BuildOrderData::hold_num[BuildOrderType::Hatchery]++;}
		else if(w.getBuilding() == BWAPI::UnitTypes::Zerg_Hive){ BuildOrderData::hold_num[BuildOrderType::Hive]++; BuildOrderData::hold_num[BuildOrderType::Hatchery]++;}
		else{
			for(int i=BuildOrderType::CreepColony; i<=BuildOrderType::UltraliskCavern; i++){
				if(w.getBuilding() == getUnitType(i)){
					BuildOrderData::hold_num[i]++;
					break;
				}
			}
		}
	}


	//݂̃xŏ
	for(int i=BuildOrderType::Carapace; i<=BuildOrderType::GameteMeiosis; i++){
		BWAPI::UpgradeType type = getUpgradeType(i);
		BuildOrderData::hold_num[i] = BWAPI::Broodwar->self()->getUpgradeLevel(type);
		if(BWAPI::Broodwar->self()->isUpgrading(type)) BuildOrderData::hold_num[i]++;
	}

	for(int i=BuildOrderType::Burrowing; i<=BuildOrderType::Parasite; i++){
		BWAPI::TechType type = getTechType(i);
		if(BWAPI::Broodwar->self()->hasResearched(type)) BuildOrderData::hold_num[i] = 1;
		if(BWAPI::Broodwar->self()->isResearching(type)) BuildOrderData::hold_num[i] = 1;
	}
	/*
	//upgrade or research building̐
	BOOST_FOREACH(BuildingData &b, buildings){
		if(!b.getUnit()->isUpgrading() &&  !b.getUnit()->isResearching()) continue;


		for(int i=BuildOrderType::Carapace; i<=BuildOrderType::GameteMeiosis; i++){
		}

		for(int i=BuildOrderType::Burrowing; i<=BuildOrderType::Parasite; i++){
		}
	}*/
}