#include "BuildingManager.h"


BuildingManager::BuildingManager(void)
{
}


BuildingManager::~BuildingManager(void)
{
}

void BuildingManager::update(){
	/*
	BOOST_FOREACH(BuildingData &b, buildings){
		if(b.getState() == BuildingState::None){
			if(b.getType() == BWAPI::UnitTypes::Zerg_Spawning_Pool){
				if(playerdata.get_mineral() >= BWAPI::UpgradeTypes::Metabolic_Boost.mineralPrice() 
					&& playerdata.get_gas() >= BWAPI::UpgradeTypes::Metabolic_Boost.gasPrice()){
					if(b.getUnit()->upgrade(BWAPI::UpgradeTypes::Metabolic_Boost)){
						playerdata.reserv_upgrade(BWAPI::UpgradeTypes::Metabolic_Boost);
						continue;
					}
				}
				if(playerdata.get_mineral() >= BWAPI::UpgradeTypes::Adrenal_Glands.mineralPrice() 
					&& playerdata.get_gas() >= BWAPI::UpgradeTypes::Adrenal_Glands.gasPrice() 
					&& CimexFlag::complete_zerg_hive){
					if(b.getUnit()->upgrade(BWAPI::UpgradeTypes::Adrenal_Glands)){
						playerdata.reserv_upgrade(BWAPI::UpgradeTypes::Adrenal_Glands);
						continue;
					}
				}

			}else if(b.getType() == BWAPI::UnitTypes::Zerg_Evolution_Chamber){
				if(playerdata.get_mineral() >= BWAPI::UpgradeTypes::Zerg_Carapace.mineralPrice() 
					&& playerdata.get_gas() >= BWAPI::UpgradeTypes::Zerg_Carapace.gasPrice()
					&& (BuildOrderData::zerg_carapace == 0
					|| (BuildOrderData::zerg_carapace == 1 && CimexFlag::complete_zerg_lair)
					|| (BuildOrderData::zerg_carapace == 2 && CimexFlag::complete_zerg_hive))){
					if(b.getUnit()->upgrade(BWAPI::UpgradeTypes::Zerg_Carapace)){
						playerdata.reserv_upgrade(BWAPI::UpgradeTypes::Zerg_Carapace);
						continue;
					}
				}
				if(playerdata.get_mineral() >= BWAPI::UpgradeTypes::Zerg_Melee_Attacks.mineralPrice() 
					&& playerdata.get_gas() >= BWAPI::UpgradeTypes::Zerg_Melee_Attacks.gasPrice()
					&& (BuildOrderData::zerg_melee_attacke_level == 0
					|| (BuildOrderData::zerg_melee_attacke_level == 1 && CimexFlag::complete_zerg_lair)
					|| (BuildOrderData::zerg_melee_attacke_level == 2 && CimexFlag::complete_zerg_hive))){
					if(b.getUnit()->upgrade(BWAPI::UpgradeTypes::Zerg_Melee_Attacks)){
						playerdata.reserv_upgrade(BWAPI::UpgradeTypes::Zerg_Melee_Attacks);
					}
				}

			}else if(b.getType() == BWAPI::UnitTypes::Zerg_Hatchery
				&& !CimexFlag::zerg_lair 
				&& !CimexFlag::complete_zerg_lair){

				if(playerdata.get_mineral() >= BWAPI::UnitTypes::Zerg_Lair 
					&& playerdata.get_gas() >= BWAPI::UnitTypes::Zerg_Lair){

					if(b.getUnit()->morph(BWAPI::UnitTypes::Zerg_Lair)){
						CimexFlag::zerg_lair = true;
						playerdata.reserv(BWAPI::UnitTypes::Zerg_Lair);
						continue;
					}
				}

			}else if(b.getType() == BWAPI::UnitTypes::Zerg_Lair 
				&& !CimexFlag::zerg_hive
				&& !CimexFlag::complete_zerg_hive
				&& CimexFlag::complete_zerg_queen_nest){

				if(playerdata.get_mineral() >= BWAPI::UnitTypes::Zerg_Hive 
					&& playerdata.get_gas() >= BWAPI::UnitTypes::Zerg_Hive){

					if(b.getUnit()->morph(BWAPI::UnitTypes::Zerg_Hive)){
						CimexFlag::zerg_hive = true;
						playerdata.reserv(BWAPI::UnitTypes::Zerg_Hive);
						continue;
					}
				}
			}
		}
	}
	*/
}


void BuildingManager::createBuilding(BWAPI::Unit *unit){
	buildings.insert(BuildingData(unit));
}

void BuildingManager::removeBuilding(BWAPI::Unit *unit){
	BuildingData temp_building;
	BOOST_FOREACH(BuildingData b, buildings){
		if(b.getId() == unit->getID()) temp_building = b;
	}
	if(temp_building.getId() != -1){
		if(temp_building.getType() == BWAPI::UnitTypes::Zerg_Hatchery){
			if(CimexFlag::next_mybase_flag && temp_building.getState() == BuildingState::Constructing){
				bool flag = true;
				BOOST_FOREACH(BWAPI::Unit* u, BWAPI::Broodwar->getUnitsInRadius(temp_next_mybase->getPosition(), 128)){
					if(!u->exists() || u->getPlayer() == BWAPI::Broodwar->enemy()) continue;
					if(u->getType().isResourceDepot()) flag = false;
				}

				if(flag){  //ɍshatchery݂ȂȂ
					CimexFlag::next_mybase_flag = false;
					mapdata.setNextMybase(temp_next_mybase); //nɖ߂
					temp_next_mybase = NULL;
					mapdata.subMybaseNum(); //my_base̐炷(sđ₵Ă)
				}
			}
		}
		buildings.erase(temp_building);
	}
}

bool BuildingManager::canBuild(BWAPI::UnitType type){
	return morph(type);
}

bool BuildingManager::canUpgrade(BWAPI::UpgradeType type){
	return upgrade(type);
}

bool BuildingManager::canResearch(BWAPI::TechType type){
	return research(type);
}

bool BuildingManager::morph(BWAPI::UnitType type) const{
	bool flag = false;
	BOOST_FOREACH(BuildingData &b, buildings){
		if(type == BWAPI::UnitTypes::Zerg_Sunken_Colony || type == BWAPI::UnitTypes::Zerg_Spore_Colony){
			if(b.getType() != BWAPI::UnitTypes::Zerg_Creep_Colony || b.getState() != BuildingState::None) continue;
		}else if(type == BWAPI::UnitTypes::Zerg_Lair){
			if(b.getType() != BWAPI::UnitTypes::Zerg_Hatchery || b.getState() != BuildingState::None) continue;
		}else if(type == BWAPI::UnitTypes::Zerg_Hive){
			if(b.getType() != BWAPI::UnitTypes::Zerg_Lair || b.getState() != BuildingState::None) continue;
		}

		if(b.getUnit()->isMorphing()) continue;

		b.getUnit()->morph(type);
		return true;
	}

	return false;
}

bool BuildingManager::upgrade(BWAPI::UpgradeType type){
	BWAPI::UnitType whatupgrade = type.whatUpgrades();
	BOOST_FOREACH(BuildingData &b, buildings){
		if(b.getType() != whatupgrade) continue;
		if(b.getUnit()->isUpgrading()) continue;
		b.getUnit()->upgrade(type);
		return true;
	}
	
	return false;
}

bool BuildingManager::research(BWAPI::TechType type){
	BWAPI::UnitType whatresearch = type.whatResearches();
	BOOST_FOREACH(BuildingData &b, buildings){
		if(b.getType() != whatresearch) continue;
		if(b.getUnit()->isResearching()) continue;
		b.getUnit()->research(type);
		return true;
	}
	
	return false;
}