#pragma once
#include "UnitManager.h"
#include "Const.h"
class BuildingManager
{
public:
	BuildingManager(void);
	~BuildingManager(void);

	void update();

	void createBuilding(BWAPI::Unit *unit);

	void removeBuilding(BWAPI::Unit *unit);

	bool canBuild(BWAPI::UnitType type);

	bool canUpgrade(BWAPI::UpgradeType type);

	bool canResearch(BWAPI::TechType type);

	bool morph(BWAPI::UnitType type) const;

	bool upgrade(BWAPI::UpgradeType type);

	bool research(BWAPI::TechType type);
};

