#pragma once
#include "WorkerManager.h"
#include "BuildingManager.h"
class ConstructionManager
{
private:
	
public:
	WorkerManager workerManager;
	BuildingManager buildingManager;

	ConstructionManager(void);
	~ConstructionManager(void);

	bool buildWorker(BWAPI::UnitType type);

	bool buildBuilding(BWAPI::UnitType type);

	bool upgradeBuilding(BWAPI::UpgradeType type);

	bool researchBuilding(BWAPI::TechType type);
};

