#include "MapData.h"

MapData::MapData(void){}

MapData::~MapData(void){}

void MapData::update(){
	if(logging_flag) out << "2-1,"<< std::endl;
	//CreepꏊɂBuildingu
	for(int i=0; i<mapwidth; i++){
		for(int j=0; j<mapheight; j++){
			buildable_map[i][j] = BWAPI::Broodwar->hasCreep(i,j); //Creep
			if(buildable_map[i][j]) buildable_map[i][j] = BWAPI::Broodwar->getUnitsOnTile(i,j).empty(); //jbgȂ
			//if(buildable_map[i][j]) BWAPI::Broodwar->drawDotMap(i*TILE_SIZE, j*TILE_SIZE, BWAPI::Colors::Green);
		}
	}
	if(logging_flag) out << "2-2,"<< std::endl;
	if(!enemybases.empty()){
		for(std::map<BWTA::BaseLocation*, bool>::iterator eb = enemybases.begin(); eb != enemybases.end(); eb++){
			if(!BWAPI::Broodwar->isVisible(eb->first->getTilePosition())) continue;
			bool flag = true;
			BOOST_FOREACH(BWAPI::Unit* u, BWAPI::Broodwar->getUnitsInRadius(eb->first->getPosition(), 128)){
				if(!u->exists() || u->getPlayer() == BWAPI::Broodwar->self()) continue;
				if(u->getType().isResourceDepot()) flag = false;
			}
			if(flag){
				if(logging_flag) out << "2-2-2,"<< std::endl;
				//setWaitPosition();
				if(logging_flag) out << "2-2-3,"<< std::endl;
				eraseEnemybases(eb->first);
				if(logging_flag) out << "2-2-4,"<< std::endl;
				break;
			}
		}
	}
	if(logging_flag) out << "2-3,"<< std::endl;
	if(!mybases.empty()){
		for(std::map<BWTA::BaseLocation*, int>::iterator mb = mybases.begin(); mb != mybases.end(); mb++){
			if(!BWAPI::Broodwar->isVisible(mb->first->getTilePosition())) continue;
			bool flag = true;
			BOOST_FOREACH(BWAPI::Unit* u, BWAPI::Broodwar->getUnitsInRadius(mb->first->getPosition(), 128)){
				if(!u->exists() || u->getPlayer() == BWAPI::Broodwar->enemy()) continue;
				if(u->getType().isResourceDepot()) flag = false;
			}
			if(flag){
				eraseMybases(mb->first);
				break;
			}
		}
	}
	if(logging_flag) out << "2-4,"<< std::endl;
	if(!next_mybase.empty()){
		for(std::map<int, BWTA::BaseLocation*>::iterator m = next_mybase.begin(); m != next_mybase.end(); m++){
			//BWAPI::Broodwar->drawBoxMap(m->second->getPosition().x(), m->second->getPosition().y(), m->second->getPosition().x() + TILE_SIZE, m->second->getPosition().y() + TILE_SIZE, BWAPI::Colors::White);
			//BWAPI::Broodwar->drawTextMap(m->second->getPosition().x() + TILE_SIZE*2 -10, m->second->getPosition().y() - TILE_SIZE*2, "%d", m->first);
		}
	}
	if(logging_flag) out << "2-5,"<< std::endl;
	if(BWAPI::Broodwar->getFrameCount() % (24 * 3) == 0) updateFrameTile();
	if(logging_flag) out << "2-6,"<< std::endl;
	//if(CimexFlag::next_mybase_flag) BWAPI::Broodwar->drawBoxMap(temp_next_mybase->getPosition().x(), temp_next_mybase->getPosition().y(), temp_next_mybase->getPosition().x() + TILE_SIZE, temp_next_mybase->getPosition().y() + TILE_SIZE, BWAPI::Colors::Yellow);
	if(logging_flag) out << "2-7,"<< std::endl;

	
			
}

//onStartňxĂяo
void MapData::init(){
	mapwidth = BWAPI::Broodwar->mapWidth();
	mapheight = BWAPI::Broodwar->mapHeight();
	buildable_map.resize(mapwidth, std::vector<bool>(mapheight));
	initFrameTile();
	mybase_num = 1;
	setMybases(BWTA::getRegion(BWAPI::Broodwar->self()->getStartLocation()));
	BOOST_FOREACH(BWTA::BaseLocation* b, BWTA::getStartLocations()){
		if(b == BWTA::getStartLocation(BWAPI::Broodwar->self())) continue;
		setEnemybases(b);
	}
}

//ScoutɌꏊԂ
BWTA::BaseLocation* MapData::getNextScoutgp(){
	BWTA::BaseLocation* pop;
	pop = ground_base.front();
	ground_base.pop_front();
	ground_base.push_back(pop);
	return pop;
}


BWTA::BaseLocation* MapData::getNextScoutap(){
	if(air_base.empty()) return getNextScoutgp();
	BWTA::BaseLocation* pop;
	pop = air_base.front();
	air_base.pop_front();
	air_base.push_back(pop);
	return pop;
}

BWTA::BaseLocation* MapData::getNextScoutp(){
	BWTA::BaseLocation* pop;
	pop = all_base.front();
	all_base.pop_front();
	all_base.push_back(pop);
	return pop;
}

//mybase
//VResourceDepotݒuꂽmybase,next_mybase,baseframencA
void MapData::setMybases(const BWTA::Region *r){
	ResourceManager resourceManager;
	BOOST_FOREACH(BWTA::BaseLocation *b, BWTA::getStartLocations()){
		if(b->getRegion() != r) continue; //b̒œRegionT
		if(mybases.find(b) == mybases.end()){ //܂mybasełȂȂ
			BWAPI::Position basep = b->getPosition();
			int change = 1;
			std::map<int, BWTA::BaseLocation*> alltemp, groundtemp, airtemp;
			BOOST_FOREACH(BWTA::BaseLocation *c, BWTA::getBaseLocations()){//Vȃx[Xex[Xǂ𔻒肷
				bool next_flag = false;
				int dis;
				if(!BWAPI::Broodwar->hasPath(basep, c->getPosition())){
					if(c->isStartLocation()){ //StartLocation͍ł߂(Xg1ԏ)Ƃ
						dis = change;
						change++;
					}else{
						dis = (int)c->getAirDistance(b);
					}
					airtemp.insert(std::pair<int, BWTA::BaseLocation*>(dis, c));
					alltemp.insert(std::pair<int, BWTA::BaseLocation*>(dis, c));
				}else{
					if(c->isStartLocation()){
						dis = change;
						change++;
					}else{
						dis = (int)c->getGroundDistance(b);
						next_flag = true; //̃x[X
					}
					if(next_flag) next_mybase.insert(std::pair<int, BWTA::BaseLocation*>(dis, c));
					groundtemp.insert(std::pair<int, BWTA::BaseLocation*>(dis, c));
					alltemp.insert(std::pair<int, BWTA::BaseLocation*>(dis, c));
				}
			}
			ground_base.clear();
			air_base.clear();
			all_base.clear();
			std::pair<int, BWTA::BaseLocation*> tempb;
			BOOST_FOREACH(tempb, groundtemp){
				ground_base.push_back(tempb.second);
			}
			BOOST_FOREACH(tempb, airtemp){
				air_base.push_back(tempb.second);
			}
			BOOST_FOREACH(tempb, alltemp){
				all_base.push_back(tempb.second);
			}
			if(CimexFlag::next_mybase_flag){
				CimexFlag::next_mybase_flag = false;
				temp_next_mybase = NULL;
			}
			resourceManager.setState(b, ResourceState::Mine);
			mybases.insert(std::pair<BWTA::BaseLocation*, int>(b,MyBaseProductState::Worker));
		}
		return;
	}

	BOOST_FOREACH(BWTA::BaseLocation *b, BWTA::getBaseLocations()){
		if(b->getRegion() != r) continue;
		if(mybases.find(b) == mybases.end()){
			resourceManager.setState(b, ResourceState::Mine);
			mybases.insert(std::pair<BWTA::BaseLocation*, int>(b,MyBaseProductState::Worker));
		}
		if(CimexFlag::next_mybase_flag){
				CimexFlag::next_mybase_flag = false;
				temp_next_mybase = NULL;
		}
		return;
	}
}

std::map<BWTA::BaseLocation*, int> MapData::getMybases() const
{ return mybases;}

//mybase̐YԂԂ
int MapData::getMybaseState(BWTA::BaseLocation* b){
	if(mybases.find(b) == mybases.end()){
		return -1;
	}else{
		return mybases.find(b)->second;
	}
}

//mybaseǂf
void MapData::eraseMybases(BWAPI::Position p){
	BOOST_FOREACH(BWAPI::Unit* u, BWAPI::Broodwar->getUnitsInRadius(p, 10 * 32)){
		if(u->getType() == BWAPI::UnitTypes::Zerg_Hatchery || u->getType() == BWAPI::UnitTypes::Zerg_Lair || u->getType() == BWAPI::UnitTypes::Zerg_Hive)
			return;
	}
	BWTA::Region* r = BWTA::getRegion(p);
	BOOST_FOREACH(BWTA::BaseLocation* b, r->getBaseLocations()){
		if(mybases.find(b) == mybases.end()) continue;
		mybases.erase(b);
		setNextMybase(b); //ꂽBase̊nƂĖ߂
		ResourceManager resourceManager;
		resourceManager.setState(b, ResourceState::None);
		subMybaseNum();
	}
}

void MapData::eraseMybases(BWTA::BaseLocation *b){

	if(mybases.find(b) == mybases.end()) return;

	mybases.erase(b);
	setNextMybase(b); //ꂽBase̊nƂĖ߂
	subMybaseNum();
	ResourceManager resourceManager;
	resourceManager.setState(b, ResourceState::None);
}

//enemybases & enemybases_position
//enemybasȅ8̒[̐ݒ
void MapData::setEnemybases(const BWTA::Region *r){
	BOOST_FOREACH(BWTA::BaseLocation *b, BWTA::getBaseLocations()){
		if(b->getRegion() != r) continue;
		std::map<BWTA::BaseLocation*, bool>::iterator eb = enemybases.find(b);
		if(eb == enemybases.end()){
			//setWaitPosition();
			enemybases.insert(std::pair<BWTA::BaseLocation*, bool>(b, false));

			/*std::vector<BWAPI::Position> v(8);
			for(int i=0; i<8; i++){
				BWAPI::Position p = b->getPosition();
				BWAPI::Position temp;
				BWTA::Region* br = b->getRegion();
				while(p.x()>=0 && p.x()<mapwidth * 32 && p.y()>=0 && p.y()<mapwidth * 32 && br == BWTA::getRegion(p)){
					temp = p;
					p.x() += dx[i] * 32;
					p.y() += dy[i] * 32;
				}
				v[i] = temp;
			}
			enemybases_position.insert(std::pair<BWTA::BaseLocation*, std::vector<BWAPI::Position> >(b, v));*/
			int distance = 0;
			std::map<BWTA::BaseLocation*, int>::iterator mb = mybases.begin();
			if(b->isIsland()){
				distance = (int)mb->first->getAirDistance(b);
			}else{
				distance = (int)mb->first->getGroundDistance(b);
			}
			enemybases_distance.insert(std::pair<int, BWTA::BaseLocation*>(distance, b));
		}
		return;
	}
}

void MapData::setEnemybases(BWTA::BaseLocation *b){
	if(enemybases.find(b) == enemybases.end()){
		if(logging_flag) out << "d-2" << std::endl;
		enemybases.insert(std::pair<BWTA::BaseLocation*, bool>(b, false));
		int distance = 0;
		if(logging_flag) out << "d-3" << std::endl;

		if(mybases.empty()) return; //wnȂΗ̂ŃoO΍

		std::map<BWTA::BaseLocation*, int>::iterator mb = mybases.begin();
		if(logging_flag) out << "d-3-1" << std::endl;
		if(b->isIsland()){
			if(logging_flag) out << "d-3-2" << std::endl;
			distance = (int)mb->first->getAirDistance(b);
		}else{
			if(logging_flag) out << "d-3-3" << std::endl;
			distance = (int)mb->first->getGroundDistance(b);
		}
		if(logging_flag) out << "d-4" << std::endl;
		enemybases_distance.insert(std::pair<int, BWTA::BaseLocation*>(distance, b));
		if(logging_flag) out << "d-5" << std::endl;
		//setWaitPosition();
		if(logging_flag) out << "d-6" << std::endl;
		ResourceManager resourceManager;
		resourceManager.setState(b, ResourceState::Enemy);
	}
}

void MapData::setEnemybasesBool(BWTA::BaseLocation* b, bool flag){
	if(enemybases.find(b) != enemybases.end())
		enemybases.find(b)->second = flag;
}

std::map<BWTA::BaseLocation*, bool> MapData::getEnemybases() const
{ return enemybases;}

void MapData::eraseEnemybases(BWAPI::Position p){
	BWTA::Region* r = BWTA::getRegion(p);

	BOOST_FOREACH(BWTA::BaseLocation* b, r->getBaseLocations()){

		if(enemybases.find(b) == enemybases.end()) continue;
		//if(enemybases_position.find(b) == enemybases_position.end()) continue;
		enemybases.erase(b);
		//enemybases_position.erase(b);

		std::map<int, BWTA::BaseLocation*>::iterator ebd_erase;
		for(std::map<int, BWTA::BaseLocation*>::iterator ebd = enemybases_distance.begin(); ebd != enemybases_distance.end(); ebd++){
			if(ebd->second != b) continue;
			ebd_erase = ebd;
			break;
		}
		enemybases_distance.erase(ebd_erase);
		setNextMybase(b);
	}
}

void MapData::eraseEnemybases(BWTA::BaseLocation *b){

		if(enemybases.find(b) == enemybases.end()) return;
		
		enemybases.erase(b);

		std::map<int, BWTA::BaseLocation*>::iterator ebd_erase;
		for(std::map<int, BWTA::BaseLocation*>::iterator ebd = enemybases_distance.begin(); ebd != enemybases_distance.end(); ebd++){
			if(ebd->second != b) continue;
			ebd_erase = ebd;
			break;
		}
		enemybases_distance.erase(ebd_erase);
		setNextMybase(b);
}

BWTA::BaseLocation* MapData::getNearEnemybase(){
	if(enemybases.empty()) return BWTA::getStartLocation(BWAPI::Broodwar->self());
	std::map<int, BWTA::BaseLocation*>::iterator ebd = enemybases_distance.begin();
	return ebd->second;
}

std::map<BWTA::BaseLocation*, std::vector<BWAPI::Position> > MapData::getEnemybasesPosition() const
{ return enemybases_position;}

//ɌꏊԂ
BWAPI::Position MapData::getEnemybasesPosition(BWTA::BaseLocation* b, int i) const
{
	return enemybases_position.find(b)->second[i];
}


//buildable_map
void MapData::setBuildableMap(int x, int y, bool flag){
	if(x < 0 || y < 0 || x >= mapwidth || y >= mapheight) return;
	buildable_map[x][y] = flag;
}

std::vector<std::vector<bool>> MapData::getBuildableMap() const
{ return buildable_map;}


//mapwdth & mapheight
int MapData::getMapwidth() const
{ return mapwidth;}

int MapData::getMapheight() const
{ return mapheight;}


//next_mybase & mybase_num
//G̊nł͂ȂATς݂Ȃ玟̊nԂ@next_mybase炻̈ʒuerase
BWTA::BaseLocation* MapData::getNextMybase()
{
	for(std::map<int, BWTA::BaseLocation*>::iterator nm = next_mybase.begin(); nm != next_mybase.end(); nm++){ //KX̂ꏊD
		BWTA::BaseLocation* b = nm->second;
		if(enemybases.find(b) == enemybases.end() && !b->isMineralOnly()){
			next_mybase.erase(nm);
			return b;
		}
	}
	for(std::map<int, BWTA::BaseLocation*>::iterator nm = next_mybase.begin(); nm != next_mybase.end(); nm++){ //KXȂĂǂ
		BWTA::BaseLocation* b = nm->second;
		if(enemybases.find(b) == enemybases.end()){
			next_mybase.erase(nm);
			return b;
		}
	}
	return NULL;
}

//eraseĂ܂BaseĂі߂ۂɎg
void MapData::setNextMybase(BWTA::BaseLocation* b){
	if(next_mybase.find((int)b->getGroundDistance(b)) != next_mybase.end()) return;
	if(!b->isIsland()){
		std::vector<int> v(2);
		v[0] = (int)b->getGroundDistance(b);
		next_mybase.insert(std::pair<int, BWTA::BaseLocation*>(v[0], b));
	}
}

int MapData::getMybaseNum() const
{ return mybase_num;}

void MapData::addMybaseNum(){
	mybase_num++;
}

void MapData::subMybaseNum(){
	mybase_num--;
}

BWTA::BaseLocation* MapData::getFrontLine(){
	if(!mybases.empty() && !enemybases.empty()){
		//out2 << "2-0-4" << std::endl;
		int min_dis = 100000;
		BWTA::BaseLocation *min_b, *eb = getNearEnemybase();
		//out2 << "2-0-5" << std::endl;
		for(std::map<BWTA::BaseLocation*, int>::iterator m = mybases.begin(); m != mybases.end(); m++){
			int dis = m->first->getPosition().getApproxDistance(eb->getPosition());
			if(min_dis > dis){
				min_dis = dis;
				min_b = m->first;
			}
		}
		//out2 << "2-0-6" << std::endl;
		return min_b;
	}else{
		return BWTA::getStartLocation(BWAPI::Broodwar->self());
	}
}

void MapData::setWaitPosition(){
	if(enemybases.empty() || mybases.empty()) return;

	int min_dis = 10000000;
	BWTA::Chokepoint *min_c;
	BOOST_FOREACH(BWTA::Chokepoint *c, mapdata.getNearEnemybase()->getRegion()->getChokepoints()){
		int dis = mapdata.getMybases().begin()->first->getPosition().getApproxDistance(c->getCenter());
		if(dis < min_dis){
			min_dis = dis;
			min_c   = c;
		}
	}
	int side = 0; //1:first  2:second
	int dis = 0;
	int vec_x = min_c->getSides().first.y() - min_c->getSides().second.y(), vec_y = min_c->getSides().second.x() - min_c->getSides().first.x();
	BWAPI::Position first(min_c->getCenter().x() + vec_x, min_c->getCenter().y() + vec_y),
					second(min_c->getCenter().x() - vec_x, min_c->getCenter().y() - vec_y);

	dis = mapdata.getMybases().begin()->first->getPosition().getApproxDistance(first);
	if(dis < min_dis){
		min_dis = dis;
		side = 1;
	}
	dis = mapdata.getMybases().begin()->first->getPosition().getApproxDistance(second);
	if(dis < min_dis){
		min_dis = dis;
		side = 2;
	}
	int x, y;
	if(side == 1){
		x = first.x() - (second.x() - first.x()) * 3;
		y = first.y() - (second.y() - first.y()) * 3;
		wait_position = BWAPI::Position(x,y);
	}else if(side == 2){
		x = second.x() - (first.x() - second.x()) * 3;
		y = second.y() - (first.y() - second.y()) * 3;
		wait_position = BWAPI::Position(x,y);
	}else{
		wait_position = min_c->getCenter();
	}
}

void MapData::updateWaitPosition(BWAPI::Position p){
	if(enemybases.empty() || mybases.empty()) return;

	if(wait_position.getApproxDistance(p) > 128) return;

	int min_dis = 10000000;
	BWTA::Chokepoint *min_c;
	BOOST_FOREACH(BWTA::Chokepoint *c, BWTA::getRegion(p)->getChokepoints()){
		int dis = mapdata.getMybases().begin()->first->getPosition().getApproxDistance(c->getCenter());
		if(dis < min_dis){
			min_dis = dis;
			min_c   = c;
		}
	}
	int side = 0; //1:first  2:second
	int dis = 0;
	int vec_x = min_c->getSides().first.y() - min_c->getSides().second.y(), vec_y = min_c->getSides().second.x() - min_c->getSides().first.x();
	BWAPI::Position first(min_c->getCenter().x() + vec_x, min_c->getCenter().y() + vec_y),
					second(min_c->getCenter().x() - vec_x, min_c->getCenter().y() - vec_y);

	dis = mapdata.getMybases().begin()->first->getPosition().getApproxDistance(first);
	if(dis < min_dis){
		min_dis = dis;
		side = 1;
	}
	dis = mapdata.getMybases().begin()->first->getPosition().getApproxDistance(second);
	if(dis < min_dis){
		min_dis = dis;
		side = 2;
	}
	int x, y;
	if(side == 1){
		x = first.x() - (second.x() - first.x()) * 3;
		y = first.y() - (second.y() - first.y()) * 3;
		wait_position = BWAPI::Position(x,y);
	}else if(side == 2){
		x = second.x() - (first.x() - second.x()) * 3;
		y = second.y() - (first.y() - second.y()) * 3;
		wait_position = BWAPI::Position(x,y);
	}else{
		wait_position = min_c->getCenter();
	}
}

BWAPI::Position MapData::getWaitPosition(){
	if(wait_position == NULL){
		if(mapdata.getEnemybases().empty()){
			if(mapdata.getMybases().empty()){
				return BWAPI::Position(BWAPI::Broodwar->self()->getStartLocation().x()*TILE_SIZE, BWAPI::Broodwar->self()->getStartLocation().y()*TILE_SIZE);
			}else{
				return mapdata.getMybases().begin()->first->getPosition();
			}
		}
		if(mapdata.getMybases().empty()) return mapdata.getMybases().begin()->first->getPosition();
	}
	return wait_position;
}

void MapData::setWaitToMy(){
	wait_position = getFrontLine()->getPosition();
}

void MapData::initFrameTile(){
	frame_tile.resize(mapwidth - 10, std::vector<int>(mapheight - 10));
	gradation_frame_tile.resize(mapwidth - 10, std::vector<int>(mapheight - 10));
	for(int x=0; x<mapwidth-10; x++){
		for(int y=0; y<mapheight-10; y++){
			frame_tile[x][y] = 0;
			gradation_frame_tile[x][y] = 0;
		}
	}

	BOOST_FOREACH(BWTA::BaseLocation *b, BWTA::getBaseLocations()){
		if(b->isStartLocation()){
			frame_tile[b->getTilePosition().x()-5][b->getTilePosition().y()-5] -= 1000000;
		}else{
			frame_tile[b->getTilePosition().x()-5][b->getTilePosition().y()-5] -= 500000;
		}
	}
}

void MapData::updateFrameTile(){
	for(int x=0; x<mapwidth-10; x++){
		for(int y=0; y<mapheight-10; y++){
			if(BWAPI::Broodwar->isVisible(x+5, y+5)){
				int danger = 0;
				BOOST_FOREACH(BWAPI::Unit *u, BWAPI::Broodwar->getUnitsOnTile(x+5, y+5)){
					if(u->getPlayer() == BWAPI::Broodwar->self()) continue;
					if(u->getType().isCloakable() || u->getType().isBurrowable()){
						danger = INT_MIN;
					}else if(u->getType().airWeapon() == BWAPI::WeaponTypes::None)
						continue;
					danger += INT_MAX / 20000;
				}
				frame_tile[x][y] = BWAPI::Broodwar->getFrameCount() + danger;
			}
		}
	}
}

//ڂ
void MapData::gradateFrameTile(int x, int y){
	int sum_frame = 0, num = 0;
	for(int i=x-5; i<=x+5; i++){
		for(int j=y-5; j<=y+5; j++){
			if(i<0 || j<0 || i>=mapwidth-10 || j>=mapheight-10) continue;
			sum_frame += frame_tile[i][j];
			num++;
		}
	}
	gradation_frame_tile[x][y] = sum_frame / num;
}

std::vector<std::vector<int>> MapData::getGradationFrameTile(){
	return gradation_frame_tile;
}

BWAPI::Position MapData::getAirScoutPosition(BWAPI::Position p){
	int x1 = p.x() / 32 - 10,
		x2 = p.x() / 32 + 10,
		y1 = p.y() / 32 - 10,
		y2 = p.y() / 32 + 10;

	//͈͊O̒
	if(x1 < 5) x1 = 5;
	else if(x1 >= mapwidth - 5) x1 = mapwidth - 6;

	if(y1 < 5) y1 = 5;
	else if(y1 >= mapheight - 5) y1 = mapheight - 6;

	if(x2 < 5) x2 = 5;
	else if(x2 >= mapwidth - 5) x2 = mapwidth - 6;

	if(y2 < 5) y2 = 5;
	else if(y2 >= mapheight - 5) y2 = mapheight - 6;

	//ڂ
	gradateFrameTile(x1-5, y1-5);
	gradateFrameTile(x1-5, y2-5);
	gradateFrameTile(x2-5, y1-5);
	gradateFrameTile(x2-5, y2-5);

	double dvecx = (double)((gradation_frame_tile[x1-5][y1-5] - gradation_frame_tile[x2-5][y1-5]) * (y2 * 32 - p.y()) + (gradation_frame_tile[x1-5][y2-5] - gradation_frame_tile[x2-5][y2-5]) * (p.y() - y1 * 32)) / ((x2 - x1) * (y2 - y1));
	double dvecy = (double)((gradation_frame_tile[x1-5][y1-5] - gradation_frame_tile[x1-5][y2-5]) * (x2 * 32 - p.x()) + (gradation_frame_tile[x2-5][y1-5] - gradation_frame_tile[x2-5][y2-5]) * (p.x() - x1 * 32)) / ((x2 - x1) * (y2 - y1));

	int vecx = ceil(dvecx / sqrt(dvecx * dvecx + dvecy * dvecy) * 10);
	int vecy = ceil(dvecy / sqrt(dvecx * dvecx + dvecy * dvecy) * 10);

	if(vecx == 0 && vecy == 0) return p;

	int ansx = p.x(), ansy = p.y();
	bool first = true;
	while(1){
		bool flag = false;
		ansx += vecx;
		ansy += vecy;
		if(first){
			first = false;
			//BWAPI::Broodwar->drawCircleMap(ansx, ansy, 10, BWAPI::Colors::Red);
		}
		if(ansx < 0 || ansx >= mapwidth * TILE_SIZE){
			ansx -= vecx;
			flag = true;
		}
		if(ansy < 0 || ansy >= mapheight * TILE_SIZE){
			ansy -= vecy;
			flag = true;
		}
		if(flag) break;
	}

	return BWAPI::Position(ansx, ansy);
}