#pragma once
#include <BWAPI.h>
#include "Const.h"
class PlayerData
{
private:
	int mineral;
	int build_mineral; //\񂵂mineral@ȉl
	int gas;
	int build_gas;
	int supplytotal;
	int build_supplytotal;
	int supplyused;
public:

	PlayerData(void);

	~PlayerData(void);

	void update();

	int get_mineral() const;
	
	int get_gas() const;

	int get_supplytotal() const;

	int get_build_supplytotal() const;

	int get_supplyused() const;

	void reserv(BWAPI::UnitType type);

	void reserv(BWAPI::UpgradeType type);

	void reserv(BWAPI::TechType type);

	void add_build_supplytotal();

	void sub_build_supplytotal();

	void add_build_reserv(BWAPI::UnitType type);

	void sub_build_reserv(BWAPI::UnitType type);

	bool canMake(BWAPI::UnitType type);

	bool canUpgrade(BWAPI::UpgradeType type);

	bool canResearch(BWAPI::TechType type);

	bool orderDrone();
};

