#pragma once
#include <BWAPI.h>

class UnitData
{
private:
	BWAPI::Unit* unit;
	BWAPI::Position position;
	int id;
	int size[4];
	BWAPI::UnitType type;
public:
	UnitData();

	UnitData(BWAPI::Unit* u);

	virtual ~UnitData(void);

	void unit_update();

	BWAPI::Position getPosition() const;

	const int * getSize() const;

	BWAPI::Unit * getUnit() const;

	BWAPI::UnitType getType() const;

	int getId() const;

	void setType(BWAPI::UnitType t);

	bool operator==(const UnitData &right) const;

	bool operator < (const UnitData &right) const;
};

